using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication21
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.gridControl1.ColWidths[1] = 150;
            this.gridControl1[1, 1].Text = "This is the time.";
            this.gridControl1.CurrentCellKeyDown += new KeyEventHandler(gridControl1_CurrentCellKeyDown);
        }

        void gridControl1_CurrentCellKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Control && gridControl1.CurrentCell.IsEditing)
            {
                switch (e.KeyCode)
                {
                    case Keys.Right:
                        {
                            TextBox tb = gridControl1.CurrentCell.Renderer.Control as TextBox;
                            if (tb != null)
                            {
                                int i = tb.SelectionStart + 1;
                                bool spaceHit = false;
                                while (i < tb.Text.Length && !spaceHit)
                                {
                                    spaceHit = char.IsWhiteSpace(tb.Text[i]);
                                    i++;
                                }
                                tb.SelectionStart = i;
                                tb.SelectionLength = 0;
                                e.Handled = true;
                            }
                        }
                        break;
                    case Keys.Left:
                        {
                            TextBox tb = gridControl1.CurrentCell.Renderer.Control as TextBox;
                            if (tb != null)
                            {
                                int i = tb.SelectionStart - 1;
                                bool firstTime = true;
                                while (i > 0)
                                {
                                    if (!firstTime && char.IsWhiteSpace(tb.Text[i]))
                                    {
                                        i++;
                                        break;
                                    }
                                    firstTime = false;
                                    i--;
                                }
                                tb.SelectionStart = Math.Max(i, 0);
                                tb.SelectionLength = 0;
                                e.Handled = true;
                            }
                        }
                        break;
                    default:
                        break;

                }
            }
        }
    }
}